
#include "stdafx.h"
#include <windows.h> 
#include <winsock2.h>
#include "BMFBioUPIDemo.h"
#include "BMFBioUPIDemoDlg.h"



#define PORTNUM               5000    // Port number  
#define MAX_PENDING_CONNECTS  10      // Maximum length of the queue 
                                      // of pending connections



CWinThread* ScanEFISThread[64];
//HANDLE	hMutex_serv = NULL;



UINT	CBMFBioUPIDemoDlg::ThreadServer(LPVOID Par)
{
CBMFBioUPIDemoDlg * m_Dlg = (CBMFBioUPIDemoDlg *)Par;


SOCKET WinSocket = INVALID_SOCKET;  // Window socket
       
SOCKADDR_IN local_sin;              // Local socket address

TCHAR szError[100];                 // Error message string
PHOSTENT phostent = NULL;

int	status, err, lasterror = 0;
unsigned long nb = 1;

int	port;
CString	str_ip;

efisSetOpenTimeout(1);


//hMutex_serv = CreateMutex(NULL, FALSE, "Control_block_for_server");
//if ( hMutex_serv == NULL )	return	-1;


// Create a TCP/IP socket, WinSocket.
if ((WinSocket = socket (AF_INET, SOCK_STREAM, IPPROTO_TCP)) == INVALID_SOCKET)  {
    wsprintf (szError, TEXT("Allocating socket failed. Error: %d"), 
              WSAGetLastError ());
    m_Dlg->MessageBox (szError, TEXT("Error"), MB_OK);
    return FALSE;
}

m_Dlg->GetDlgItemText(IDC_IPADDRESS1,str_ip);
port = m_Dlg->GetDlgItemInt(IDC_PORT);


// Fill out the local socket's address information.
local_sin.sin_family = AF_INET;
local_sin.sin_port = htons (port);  

if ((phostent = gethostbyname(str_ip.GetBuffer(0))) == NULL)  {
	return	FALSE;
}


// Assign the socket IP address.
memcpy ((char FAR *)&(local_sin.sin_addr), phostent->h_addr, phostent->h_length);


// Associate the local address with WinSocket.
if (bind (WinSocket, 
            (struct sockaddr *) &local_sin, 
            sizeof (local_sin)) == SOCKET_ERROR) 
  {
    wsprintf (szError, TEXT("Binding socket failed. Error: %d"), 
              WSAGetLastError ());
    m_Dlg->MessageBox (szError, TEXT("Error"), MB_OK);
    closesocket (WinSocket);
    return FALSE;
  }

	lasterror = ioctlsocket(WinSocket, FIONBIO, (unsigned long *) &nb);
	if ( lasterror == SOCKET_ERROR ) {
		lasterror = -7;
		return FALSE;
	}

  // Establish a socket to listen for incoming connections.
  if (listen (WinSocket, MAX_PENDING_CONNECTS) == SOCKET_ERROR) 
  {
    wsprintf (szError, 
              TEXT("Listening to the client failed. Error: %d"),
              WSAGetLastError ());
    m_Dlg->MessageBox(szError, TEXT("Error"), MB_OK);
    closesocket (WinSocket);
    return FALSE;
  }

m_Dlg->accept_sin_len = sizeof(m_Dlg->accept_sin);

while(1) {
	WaitForSingleObject(m_Dlg->s_DoEvent,INFINITE);

	if  ( TreatStatusServ == FALSE )	break;
	status = 0;

	// Accept an incoming connection attempt on WinSocket.
	m_Dlg->ClientSock = accept(WinSocket, (struct sockaddr *) &(m_Dlg->accept_sin), (int *) &(m_Dlg->accept_sin_len));

	if (m_Dlg->ClientSock == INVALID_SOCKET)  {
		err = WSAGetLastError();
		if ( err == 10035 )	{ Sleep(2); continue; }
		else {
			err = WSAGetLastError();
		}
	}
	else {
		status = 0;	
	}

	if  ( TreatStatusServ == FALSE )	break;

	// my test 
	//err = recv(m_Dlg->ClientSock, szError, 3, 0);
	//break;

	m_Dlg->handleEFIS = efisOpenDeviceBySocketI(m_Dlg->ClientSock);
	//m_Dlg->handleEFIS = efisOpenDeviceBySocket(TYPESCANNER_EFIS121, m_Dlg->ClientSock);
	if ( m_Dlg->handleEFIS < 0 )	continue;

	ScanEFISThread[m_Dlg->handleEFIS] = AfxBeginThread(ThreadEFISScanner,m_Dlg);
	Sleep(10);	//	it's very importent for correct work
}


shutdown (WinSocket, 0x00);	//	was 0x00
Sleep(100);
//Close the socket.
closesocket (WinSocket);

return	0;
}

/*
*/
UINT	CBMFBioUPIDemoDlg::ThreadEFISScanner(LPVOID Par)
{
CBMFBioUPIDemoDlg* m_Dlg = (CBMFBioUPIDemoDlg*)Par;

int	ret, ret1, handle1, status;
unsigned char bimgs[750000];
char in_addr[16];
int	Himg, Wimg;

ProcTemp	b(THOMSON, 50);

handle1 = m_Dlg->handleEFIS;


sprintf(in_addr,"%d.%d.%d.%d", m_Dlg->accept_sin.sin_addr.S_un.S_un_b.s_b1, m_Dlg->accept_sin.sin_addr.S_un.S_un_b.s_b2, m_Dlg->accept_sin.sin_addr.S_un.S_un_b.s_b3, m_Dlg->accept_sin.sin_addr.S_un.S_un_b.s_b4);

status = 0;

while(1) {
	ret = efisIsFingerPresentV2(handle1);
	if ( ret == rcOK ) {
		efisGetImageV2(handle1, bimgs);
		Himg = efisGetHeight(handle1);
		Wimg = efisGetWidth(handle1);

		status = 0;
		m_Dlg->MyPaint(&bimgs[0], Wimg, Himg);

		ret1 = m_Dlg->ControlEFISEvents(handle1, &bimgs[0], Wimg, Himg, in_addr, b);
		if ( efisGetType(handle1) == TYPESCANNER_EFIS121 )	break;
		if ( efisGetType(handle1) == TYPESCANNER_EFIS321 && ret1 == 1)	{
			Sleep(1000);
			break;
		}

	}
	else {
		if ( status == 0 ) { 
			//status++; 
			//continue; 
		}
		break;
	}
}

efisCloseSocketByDevice(handle1);
Sleep(300);
efisCloseDevice(handle1);

return	0;
}


/*
*/
int	CBMFBioUPIDemoDlg::ControlEFISEvents(int handle1, unsigned char * ptr_img, int W, int H, char * in_addr, ProcTemp & b)
{
char	msg[256];
int	ret;
CWnd* pWnd = GetDlgItem(IDC_STATUSINFO);
CString	str;
int	i, j, count_retry;
int	handleEREL;
//unsigned char stat_relay[9], nrelay;


//WaitForSingleObject(hMutex_app,INFINITE);

//sprintf(in_addr,"%d.%d.%d.%d", accept_sin.sin_addr.S_un.S_un_b.s_b1, accept_sin.sin_addr.S_un.S_un_b.s_b2, accept_sin.sin_addr.S_un.S_un_b.s_b3, accept_sin.sin_addr.S_un.S_un_b.s_b4);

erelSetOpenTimeout(1);


b.IdentifyInit(ptr_img, W, H);

ret = 0;
for(i = 0; i < number_tmp; i++) {
	ret = b.IdentifyFind(tempu[i].temp);
	if ( ret >= 17 )	break;
}

for(j = 0; j < number_row; j++) {
	if ( tempu[i].ID == users[j].ID )	break;
}

//ReleaseMutex(hMutex_app);

CTime t = CTime::GetCurrentTime();
CString s = t.Format("%H:%M:%S, %d/%m/%Y");


if  ( ret >= 17 ) {
	sprintf(msg, "%s, %s, %s is verified, ID=%d, (%d)", s.GetBuffer(0), in_addr, users[j].lname, tempu[i].ID, ret );


	m_ListMsg.InsertItem( nummsg_row, (char *)msg);
	m_ListMsg.SetItemText( nummsg_row, 0, (char *)msg);
	nummsg_row++;

	//efisRelayTimer(handle);

	efisLedTimer(handle1, LED1_GREEN_ON, 3);

	//MessageBox(msg, "Verification", MB_OK | MB_ICONASTERISK |MB_ICONINFORMATION);
	SetDlgItemText(IDC_STATUSINFO,msg);

	// search of erel for scanner
	for(i = 0; i < numref_row; i++) {
		if ( strcmp((const char *)cref[i].ipscn, (const char *)in_addr) == 0) {

			count_retry = 0;

			while(1) {
				handleEREL = erelOpenDevice(TYPEDEVICE_EREL112, cref[i].iprel, cref[i].prrel);
				if ( handleEREL < 0 )	{
					if ( count_retry >= 5 )	break;
				}
				else {
					break;
				}
				Sleep(200);
				count_retry++;
			}
			if ( handleEREL < 0 )	{
				sprintf(msg, "%s, Scanner %s - Relay %s doesn't work", s.GetBuffer(0), in_addr, cref[i].iprel );
				SetDlgItemText(IDC_STATUSINFO,msg);

				m_ListMsg.InsertItem( nummsg_row, (char *)msg);
				m_ListMsg.SetItemText( nummsg_row, 0, (char *)msg);
				nummsg_row++;
				break;
			}


			//erelRelayOn(handleEREL, S_RELAY_1);
			//Sleep(cref[i].delay*1000);
			//erelRelayOff(handleEREL, S_RELAY_1);
			
			erelRelayOnTimer(handleEREL, 1 << ((unsigned char)cref[i].relay - 1), (unsigned char)cref[i].delay);

			//erelGetStatusRelay(handleEREL, stat_relay);
			//if ( (stat_relay[0] & 0x01) == 1 ) {
			//	erelRelayOff(handleEREL, S_RELAY_1);
			//}
			//Sleep(10);

			erelCloseDevice(handleEREL);
			break;
		}
	}
	//efisLedOFF(handle, LED1_GREEN_OFF);

	return	1;


}
else {
	efisLedTimer(handle1, LED1_RED_ON, 2);
	sprintf(msg, "%s, %s, Person is not verified              ", s.GetBuffer(0), in_addr);

	m_ListMsg.InsertItem( nummsg_row, (char *)msg);
	m_ListMsg.SetItemText( nummsg_row, 0, (char *)msg);
	nummsg_row++;

	//MessageBox(msg, "Verification", MB_OK | MB_ICONASTERISK |MB_ICONINFORMATION);
	SetDlgItemText(IDC_STATUSINFO,msg);
}

return	0;
}


void CBMFBioUPIDemoDlg::MyPaint(unsigned char * ptr_img, int W, int H)
{
	short	color;

	CWnd* pWnd = GetDlgItem(IDC_IMAGE);
	CClientDC pControlDC(pWnd);
	RECT	rect;

	int	deltaX=1;
	int	deltaY=4;

	if  ( pimg == NULL )	return;


	pWnd->GetWindowRect(&rect);

	rect.left=5; 
	rect.top=15;
	rect.bottom = rect.top  + H-deltaY;
	rect.right  = rect.left + W-deltaX;

	CBitmap * oldBitmap;
	CRect clientRect;

	CDC * m_pdcDisplayMemory = new CDC;
	CBitmap * m_pBitmap = new CBitmap;
			
	if (m_pdcDisplayMemory->GetSafeHdc() == NULL) 
	{
		m_pdcDisplayMemory->CreateCompatibleDC(&pControlDC);
		m_pBitmap->CreateCompatibleBitmap(
				&pControlDC
				,W-deltaX 
				,H-deltaY
				);

		oldBitmap = m_pdcDisplayMemory->SelectObject(m_pBitmap);
	}
	int x0 = rect.left;
	int y0 = rect.top;
	int Beg=0;
		
	for(unsigned int j=0; j<(unsigned)(H-deltaY);j++)
	{
		for(unsigned int i=0;i<(unsigned)(W-deltaX);i++)
		{
			color = ptr_img[Beg+i+j*W];
			m_pdcDisplayMemory->SetPixel(i,j,RGB(color,color,color)); 
		}
	}

	pControlDC.StretchBlt(x0, y0, 
			W-deltaX , 
			H-deltaY, 
			m_pdcDisplayMemory, 
			0, 0, 
			W-deltaX , 
			H-deltaY, 
			SRCCOPY);

	delete m_pdcDisplayMemory;
	delete m_pBitmap;
		
}
